package org.bdware.server.nodecenter;

import com.google.gson.JsonObject;
import com.google.gson.JsonArray;
import org.bdware.sc.bean.ContractDesp;
import org.bdware.sc.conn.ResultCallback;
import org.bdware.server.action.Action;

import java.io.ByteArrayOutputStream;
import java.io.PrintStream;

public class TracingAction {
    private static JsonObject getDependentContract(JsonObject jo) {
        //考虑多层依赖
        JsonObject result = new JsonObject();
        JsonArray beDependent = new JsonArray();
        String contractName = jo.get("contractName").getAsString();
        try {
            if (!jo.has("contractName")) {
                result.addProperty("exception", "missing arguments: contractName");
                return result;
            }
            JsonArray dependencies = new JsonArray();
            for (CMNode node : NodeCenterActions.nodeInfos.values()) {
                for (ContractDesp desp : node.contracts) {
                    if (desp.contractName.equals(contractName)) {
                        if (desp.dependentContracts != null) {
                            for (String val : desp.dependentContracts)
                                dependencies.add(val);
                        }
                    } else {
                        if (desp.dependentContracts != null && desp.dependentContracts.contains(contractName)) {
                            beDependent.add(desp.contractName);
                        }
                    }
                }
            }
            result.add("dependencies", dependencies);
            result.add("beDependent", beDependent);

            return result;
        } catch (Exception e) {
            ByteArrayOutputStream bo = new ByteArrayOutputStream();
            e.printStackTrace(new PrintStream(bo));
            result.addProperty("exception", bo.toString());

            return result;
        }
    }

    @Action(async = true)
    public void getDependentContract(JsonObject json, ResultCallback rc) {
        JsonObject result = getDependentContract(json);
        JsonObject jo = new JsonObject();
        jo.add("result", result);
        jo.addProperty("action", "onGetDependentContract");
        rc.onResult(jo);
    }
}
