package org.bdware.bdserver;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class TestServer {
    private static final Logger LOGGER = LogManager.getLogger(TestServer.class);

    static class TestHandler extends SimpleChannelInboundHandler<ByteBuf> {
        TestHandler() {
            LOGGER.info("new instance");
        }

        @Override
        public void channelActive(ChannelHandlerContext ctx) {
            LOGGER.info("active");
            System.out.println("======Active=======");
            ctx.channel()
                    .writeAndFlush("ACTIVE from Server")
                    .addListener(future -> LOGGER.info("Active Send Done!!"));
        }

        @Override
        protected void channelRead0(ChannelHandlerContext ctx, ByteBuf msg) {
            LOGGER.info("receive");
        }
    }
}
